if exists ( select * from sysobjects where id = object_id ( 'A_Stat_MyCalls_Get' ))
	Drop procedure dbo.A_Stat_MyCalls_Get
GO

Create procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - , 10 - , 11 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'	

*/

	--  
	declare @filtercomment bit
	set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end

	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, Length DateTime, Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 100 ) collate database_default, 
				IsRecorded int, IdRecDir int, ALineNum nvarchar ( 10 ) collate database_default, BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 100 ) collate database_default, BStr nvarchar ( 100 ) collate database_default, IsConf int, Director uniqueidentifier, CTS DateTime )
	-------------------------------------
	--  -----------------------
	-------------------------------------

	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeAnswer, sc.TimeStop, sc.TimeStop - sc.TimeAnswer as Length, '', '',
			IsRecorded, IdRecDir, ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr,
			0 as IsConf, @id0 as Director, sc.TimeStart as CTS
		From A_Stat_Connections_1x1 sc --with ( TabLock )
			inner join @ids ids on sc.Id = ids.id

	--    ( )
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @output
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end

	-------------------------------------
	--  ----------------------
	-------------------------------------
    if (( @type = 0 ) or ( @type = 10 ) or ( @type = 11 ))
    begin
	

	--   	
	Declare @A_Stat_Conference_Ctmp1 table ( IdConn uniqueidentifier PRIMARY KEY )
	Declare @A_Stat_Conference_tmp1 table ( Id uniqueidentifier PRIMARY KEY, RecordAccess int, Director uniqueidentifier )

	Insert into @A_Stat_Conference_Ctmp1
		Select IdConn
		FROM A_Stat_Conference_Competitors scc
		Where (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
			And IdUser = @userid

	Insert into @A_Stat_Conference_tmp1
		Select Id, RecordAccess, Director 
		FROM A_Stat_Conference sc
		Where (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart < @dstop ) and ( TimeStop >= @dstop ))
			or (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart >= @dstart ) and ( TimeStop <= @dstop ))

	--    ( )
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @A_Stat_Conference_tmp1
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end

	--   
	Declare @A_Stat_Conference_tmp2 table ( Id uniqueidentifier PRIMARY KEY )

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
		Where sc.RecordAccess = 1 --  
			And sc.Director = @userid

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
		Where sc.RecordAccess = 2 -- 
			And scc.IdUser = @userid
		Group By sc.Id

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join A_Stat_Conference_RecordAccessUsers scr on sc.Id = scr.IdConf
		Where sc.RecordAccess = 3 --  
			And scr.IdUser = @userid
		Group By sc.Id

		

	Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into @output
		Select IdConn, IdChain, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end, 
			case when sc.Type = 1 then 11/**/ else 10/**/ end,
			scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, LineNum, sc.Room, 
			scc.IdUser, @idconfuser,
			scc.IdLine, IdConf,
			'', '', StrName, case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, Director, sc.TimeStart as CTS
		FROM A_Stat_Conference_Competitors scc
			Inner join A_Stat_Conference sc on sc.Id = scc.IdConf
			Left join @A_Stat_Conference_tmp2 sct on sc.Id = sct.Id --    
		Where ((( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart < @dstop ) and ( scc.TimeStop >= @dstop ))
			or (( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart >= @dstart ) and ( scc.TimeStop <= @dstop )))
			And scc.IdUser = @userid
			And ((( sc.Type = 1 ) and ( @type = 11 )) or (( sc.Type = 0 ) and ( @type = 10 )) or ( @type = 0 ))
    end

	-----------------------------------
  	--  -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From @output o
	Where o.AbonentName = o.Number

	
	Select sc.Id, IdChain, Media, Type, TimeStart, TimeAnswer, TimeStop, Cast ( Cast ( Length as float ) * 86400 as int ) as Length, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir, 
		IsConf, Director, CTS, 
		case When ( c.Id is null ) then 0 else 1 end as HasComment		
	From @output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where ( Media = @media ) or ( @media = 0 ) or ( Type >= 10 )
	Order By TimeStart Desc
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Clients__GetJournal' ))
	Drop procedure dbo.A_Clients__GetJournal
GO

Create procedure [dbo].[A_Clients__GetJournal]
	@idclient	uniqueidentifier,
	@dstart		datetime,
	@dstop		datetime,
	@tstart		datetime,
	@tstop		datetime,
	@idoperator	uniqueidentifier,
	@iduser		uniqueidentifier
as
begin
	
	Declare @tstartfloat float
	Declare @tstopfloat float
	Set @tstartfloat =  Convert ( float, @tstart ) - FLOOR ( Convert ( float, @tstart ) )
	Set @tstopfloat =  Convert ( float, @tstop ) - FLOOR ( Convert ( float, @tstop ) )

	--    

	Declare @userspermitted table ( Id uniqueidentifier )
	Insert into @userspermitted
		Select UserB 
		From A_UserControls
		Where UserA = @iduser

	Insert into @userspermitted ( Id ) Values ( @iduser )


	Declare @linespermitted table ( Id uniqueidentifier )
	Insert into @linespermitted
		Select IdLine
		From A_UserControlLines
		Where UserA = @iduser and IdLine != '11111111-1111-1111-1111-111111111111'

	declare @canlistenext int
	Select @canlistenext = Count ( * ) From A_UserControlLines where UserA = @iduser and IdLine = '11111111-1111-1111-1111-111111111111'

	if ( @canlistenext > 0 )
	Insert into @linespermitted
		Select Id 
		From A_ServerExtLines

	---  

	Select * FROM 
	(
		Select sc.Id, sc.IdChain, 
			sc.TimeStart, 
			sc.TimeAnswer,
			sc.TimeStop,
			Cast ( Cast ( sc.TimeStop - sc.TimeAnswer as float ) * 86400 as int ) as Length,
			AStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile,
			--sc.BRecFile,
			0 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.BOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.BOutNumber) or (sc.BOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id and c.Id = @idclient
			Left join @userspermitted u on sc.AUserId = u.Id
			Left join @linespermitted l on sc.ALineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.AUserId = @idoperator )

		Union
	
		Select sc.Id, sc.IdChain,
			sc.TimeStart, 
			sc.TimeAnswer,
			sc.TimeStop,
			Cast ( Cast ( sc.TimeStop - sc.TimeAnswer as float ) * 86400 as int ) as Length,
			BStr as OperatorStr, 
			case when ( u.Id is null and l.Id is null ) then 0 else sc.IsRecorded end as IsRecorded,
			IsNull ( IdRecDir, 0 ) as IdRecDir,
			sc.ALineNum,
			sc.BLineNum,
			--sc.ARecFile, 
			--sc.BRecFile,
			1 as Direction
		From A_Stat_Connections_1x1 sc -- with ( TabLock )
			Inner join A_ClientContacts cc on ( ( len ( cc.Content ) >= 5 ) and ( len ( sc.AOutNumber ) >= 5 ) and ((cc.Content like '%' + sc.AOutNumber) or (sc.AOutNumber like '%' + cc.Content)) )
			Inner join A_Clients c on cc.IdClient = c.Id  and c.Id = @idclient	
			Left join @userspermitted u on sc.BUserId = u.Id
			Left join @linespermitted l on sc.BLineId = l.Id
		Where ( TimeStart >= @dstart )
			and ( TimeStop <= @dstop )
			and ( Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat )
			and ( Convert ( float, TimeStop ) - FLOOR ( Convert ( float, TimeStop ) ) <= @tstopfloat )
			and ( @idoperator = '00000000-0000-0000-0000-000000000000' or sc.BUserId = @idoperator )		

			
	) a

	Order By TimeStart Desc
		
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_GetJournal' ) )
	Drop procedure dbo.A_Stat_Office_GetJournal
GO

Create procedure [dbo].[A_Stat_Office_GetJournal]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = NULL, --Task defined
	@fromcc bit = NULL,
	@operatorid uniqueidentifier = NULL, --Operator defined
	@innerprefix nvarchar(100) = NULL, --Internal Number defined
	@outnumber nvarchar(100) = NULL,  --Out Number defined
	@conntype int = -1,
	-- @showconference int = 1,
	@comment nvarchar ( 4000 ) = NULL
as
begin	
	Declare @id0 uniqueidentifier
	Set @id0 = '00000000-0000-0000-0000-000000000000'

	Select top 0 *, 
		0 as IsConf, @id0 as Director, GetDate() as CTS, 
		0 as HasComment 
	Into #t 
	From A_Stat_Connections_1x1
	Insert into #t Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		1, -- show conference,
		@comment

	Select top 1000 t.*, 
		Cast ( Cast ( TimeStop - TimeAnswer as float ) * 86400 as int ) as Length, 
		Cast ( Cast ( TimeAnswer - TimeStart as float ) * 86400 as int ) as AnswerLength
	From #t t
	Order By TimeStart Desc
end
GO
