if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DB_GetDatabaseSize' ))
	Drop procedure dbo.A_DB_GetDatabaseSize
GO

Create procedure dbo.A_DB_GetDatabaseSize
	@db1 nvarchar(200) = '',
	@db2 nvarchar(200) = '',
	@db3 nvarchar(200) = '',
	@db4 nvarchar(200) = '',
	@db5 nvarchar(200) = '',
	@db6 nvarchar(200) = '',
	@db7 nvarchar(200) = '',
	@db8 nvarchar(200) = '',
	@db9 nvarchar(200) = ''
as
Begin

    if exists ( select * From tempdb..sysobjects where id=object_id('tempdb..#tmp'))
	Drop table #tmp

    Create table #tmp ( name nvarchar(200), db_size nvarchar(200), owner nvarchar(200), dbid int, created nvarchar(200), status nvarchar(500), compatibility_level int)
    Insert into #tmp
	exec sp_helpdb 

    Select name, db_size
    From #tmp
    Where ( name like @db1 ) 
	or ( name like @db2 ) 
  	or ( name like @db3 ) 
  	or ( name like @db4 ) 
  	or ( name like @db5 ) 
  	or ( name like @db6 ) 
  	or ( name like @db7 ) 
  	or ( name like @db8 ) 
  	or ( name like @db9 ) 

End
GO